# -*- coding: utf-8 -*-
import pygame
import random as rd
import numpy as np

dt = 0.01

class Fahrzeug(object):
	def __init__(self, x, y, richtung, v, a, v_optimal, v_original, amax, a_negativ_max, reaktionszeit, l, farbe, strasse):
		self.x = x
		self.y = y
		self.richtung = richtung
		self.v = v
		self.a = a
		self.v_optimal = v_optimal
		self.v_original = v_original
		self.amax = amax
		self.a_negativ_max = a_negativ_max
		self.reaktionszeit = reaktionszeit
		self.l = l
		self.farbe = farbe
		self.strasse = strasse
		
	# Berechnet die neue Beschleunigung	
	def change(self, fahrzeug):
		d = self.v_optimal - self.v
		# Fz ist zu langsam
		if d > 0:
			self.a = self.amax
		# Fz ist zu schnell
		elif d < 0:
			self.a = self.a_negativ_max			
	
	# Berechnet die neuen Koordinaten und die neue Geschwindigkeit		
	def fahre(self, fahrzeug):
		v0 = self.v
		if self.richtung == "x":
			self.x = 0.5 * self.a * dt**2 + v0 * dt + self.x
		elif self.richtung == "y":
			self.y = 0.5 * self.a * dt**2 + v0 * dt + self.y
		elif self.richtung == "-x":
			self.x -= 0.5 * self.a * dt**2 + v0 * dt
		elif self.richtung == "-y":
			self.y -= 0.5 * self.a * dt**2 + v0 * dt
		self.v = self.a * dt + v0
		
	# Zeichnet das Fz in Pygame
	def zeichne(self):
		if self.richtung == "x":				####
			if self.x + self.l > mapbreite*kachelgroesse:
				self.x = 10
			elif self.x < 1:
				self.x = mapbreite*kachelgroesse -10
			elif self.x > 425 and self.y > 304 and self.y < 306:
				self.y = 301
				self.richtung = "-y"
		elif self.richtung == "-x":
			if self.x + self.l > mapbreite*kachelgroesse:
				self.x = 10
			elif self.x < 1:
				self.x = mapbreite*kachelgroesse -10
			elif self.x < 125 and self.y > 285 and self.y < 287:
				self.y = 288
				self.richtung = "y"
		elif self.richtung == "y":
			if self.y + self.l > maphoehe*kachelgroesse:
				self.x = 405
				self.y = 10
			elif self.y < 1:
				self.x = 145
				self.y = maphoehe*kachelgroesse - 10
			elif self.y > 285 and self.y < 287:
				self.y = 286
				self.richtung = "-x"
		elif self.richtung == "-y":			#####
			if self.y + self.l > maphoehe*kachelgroesse:
				self.x = 405
				self.y = 10
			elif self.y < 1:
				self.x = 145
				self.y = maphoehe*kachelgroesse - 10
			elif self.y < 305 and self.y > 302:
				self.y = 305
				self.richtung = "x"
		pygame.draw.rect(screen, self.farbe, [self.x, self.y, self.l, 10], 0)
		
	def pruefe_ampel(self):
		if self.richtung == "x":
			for i in self.strasse.ampelliste:
				dist = i.x - self.x
				disty = i.y - self.y
				if disty < 20 and disty > -20:
					if dist < 55 and dist > 0 and i.zustand == 2:
						self.v_optimal = 0
					elif dist < 55 and dist > 0 and i.zustand == 1:
						self.v_optimal = 0
		elif self.richtung == "y":
			for i in self.strasse.ampelliste:
				dist = i.y - self.y
				if dist < 55 and dist > 0 and i.zustand == 2:
					self.v_optimal = 0
				elif dist < 55 and dist > 0 and i.zustand == 1:
					self.v_optimal = 0
		elif self.richtung == "-x":
			for i in self.strasse.ampelliste:
				dist = self.x - i.x
				disty = self.y -i.y
				if disty > -20 and disty < 20:
					if dist < 55 and dist > 0 and i.zustand == 2:
						self.v_optimal = 0
					elif dist < 55 and dist > 0 and i.zustand == 1:
						self.v_optimal = 0
		elif self.richtung == "-y":
			for i in self.strasse.ampelliste:
				dist = self.y - i.y
				if dist < 55 and dist > 0 and i.zustand == 2:
					self.v_optimal = 0
				elif dist < 55 and dist > 0 and i.zustand == 1:
					self.v_optimal = 0
					
	def pruefe_kollision(self, belegt):
		for i in range(0, len(belegt)):
			if self.richtung == "x":
				distx = belegt[i][0] - (self.x + self.l)
				disty = belegt[i][1] - (self.y)
				if disty < 5 and disty > -5:
					if distx < 10 and distx > 0:
						self.v = 0
					elif distx < self.v and distx >= self.v/2:
						self.v = -1 * dt * 100 + self.v
					elif distx < self.v/2 and distx >= self.v/4:
						self.v = -3 * dt * 100 + self.v
					elif distx < self.v/4 and distx >= 0:
						self.v = self.a_negativ_max * dt * 100 + self.v
					else:
						self.v_optimal = self.v_original
			elif self.richtung == "y":
				distx = belegt[i][0] - self.x
				disty = belegt[i][1] - (self.y + self.l)
				if distx < 5 and distx > -5:
					if disty < 10 and disty > 0:
						self.v = 0
					elif disty < self.v and disty >= self.v/2:
						self.v = -1 * dt * 100 + self.v
					elif disty < self.v/2 and disty >= self.v/4:
						self.v = -3 * dt * 100 + self.v
					elif disty < self.v/4 and disty >= 0:
						self.v = self.a_negativ_max * dt * 100 + self.v
					else:
						self.v_optimal = self.v_original 
			elif self.richtung == "-x":
				distx = self.x - (belegt[i][0] + self.l)
				disty = belegt[i][1] - (self.y)
				if disty < 5 and disty > -5:
					if distx < 10 and distx > 0:
						self.v = 0
					elif distx < self.v and distx >= self.v/2:
						self.v = -1 * dt * 100 + self.v
					elif distx < self.v/2 and distx >= self.v/4:
						self.v = -3 * dt * 100 + self.v
					elif distx < self.v/4 and distx >= 0:
						self.v = self.a_negativ_max * dt * 100 + self.v
					else:
						self.v_optimal = self.v_original
			elif self.richtung == "-y":
				distx = belegt[i][0] - self.x
				disty = self.y - (belegt[i][1] + self.l)
				if distx < 5 and distx > -5:
					if disty < 10 and disty > 0:
						self.v = 0
					elif disty < self.v and disty >= self.v/2:
						self.v = -1 * dt * 100 + self.v
					elif disty < self.v/2 and disty >= self.v/4:
						self.v = -3 * dt * 100 + self.v
					elif disty < self.v/4 and disty >= 0:
						self.v = self.a_negativ_max * dt * 100 + self.v
					else:
						self.v_optimal = self.v_original
		
class Fahrbahn(object):
	def __init__(self, startkachel, endkachel, f_richtung, fahrzeugliste, ampelliste):
		self.startkachel = startkachel
		self.endkachel = endkachel
		self.f_richtung = f_richtung
		self.fahrzeugliste = fahrzeugliste
		self.ampelliste = ampelliste
		
	def zeichne_fahrbahn(self):
		if self.f_richtung == "x":
			for i in range(self.startkachel[0],self.endkachel[0]):
				tilemap[self.startkachel[1]][i] = 4
		if self.f_richtung == "y":
			for i in range(self.startkachel[1],self.endkachel[1]):
				if tilemap[i][self.startkachel[0]] == 1:
					tilemap[i][self.startkachel[0]] = 3
				else:
					tilemap[i][self.startkachel[0]] = 2
			
	def fuege_fahrzeug_hinzu(self, Fahrzeug, belegt):
		self.fahrzeugliste.append(Fahrzeug)
		belegt.append([Fahrzeug.x, Fahrzeug.y])
		
	def fuege_ampel_hinzu(self, Ampel):
		self.ampelliste.append(Ampel)
		
		
class Ampel(object):
	def __init__(self, x, y, richtung, zustand, rot_dauer, gruen_dauer):
		self.x = x
		self.y = y
		self.richtung = richtung
		self.zustand = zustand
		self.rot_dauer = rot_dauer
		self.gruen_dauer = gruen_dauer
		self.timer = 0
		self.q = 0
		
	def zeichne(self):
		if self.richtung == "x":
			pygame.draw.rect(screen, ampelfarben[self.zustand], [self.x, self.y, 5, 20], 0)
		elif self.richtung == "y":
			pygame.draw.rect(screen, ampelfarben[self.zustand], [self.x, self.y, 20, 5], 0)
			
	def phasen(self, t):
		self.t = t
		self.timer += t
		if self.zustand == 0:	#Ampel ist grün
			if self.timer >= 75*self.gruen_dauer:
				self.timer = 0
				self.zustand = 1
				self.q = 1
		if self.zustand == 1:	#Ampel ist gelb
			if self.timer >= 75*3:
				self.timer = 0
				if self.q == 0:
					self.zustand = 0
				elif self.q == 1:
					self.zustand = 2
		if self.zustand == 2:	#Ampel ist rot
			if self.timer >= 75*self.rot_dauer:
				self.timer = 0
				self.zustand = 1
				self.q = 0
 
textures = {
				1  : pygame.image.load('grass.png'),
				2  : pygame.image.load('road_intersection.png'),
				3  : pygame.image.load('road_straight.png'),
				4  : pygame.image.load('road_horizontal.png')
		   }

#Map Dimensionen
kachelgroesse	= 40
mapbreite		= 20
maphoehe		= 15

tilemap = [[1 for w in range(mapbreite)] for h in range(maphoehe)]

# Initialize the game engine
pygame.init()

belegt = []
fahrbahnliste = []

# Ampelfarben
ampelfarben = [[0,255,0],[255,255,0],[255,0,0]]

# Fenstergroesse 
screen = pygame.display.set_mode([mapbreite*kachelgroesse,maphoehe*kachelgroesse])
pygame.display.set_caption("Verkehrssimulation")
 
 
clock = pygame.time.Clock()

# Startkachel, Endkachel, Fahrzeugliste, Ampelliste
s1 = Fahrbahn([0,11],[mapbreite,11],"x",[],[])	#y=465
fahrbahnliste.append(s1)
s2 = Fahrbahn([0,3],[mapbreite,3],"x",[],[])	#y=145
fahrbahnliste.append(s2)
s3 = Fahrbahn([3,7],[11,7],"x",[],[])
fahrbahnliste.append(s3)
s4 = Fahrbahn([3,7],[3,maphoehe],"y",[],[])
fahrbahnliste.append(s4)
s5 = Fahrbahn([10,0],[10,8],"y",[],[])			#x=405
fahrbahnliste.append(s5)
s1i = Fahrbahn([0,11],[mapbreite,11],"x",[],[])	#y=445
fahrbahnliste.append(s1i)
s2i = Fahrbahn([0,3],[mapbreite,3],"x",[],[])	#y=125
fahrbahnliste.append(s2i)
s3i = Fahrbahn([3,7],[11,7],"x",[],[])
fahrbahnliste.append(s3i)
s4i = Fahrbahn([3,7],[3,maphoehe],"y",[],[])
fahrbahnliste.append(s4i)
s5i = Fahrbahn([10,0],[10,8],"y",[],[])			#x=145
fahrbahnliste.append(s5i)

s1.zeichne_fahrbahn()
s2.zeichne_fahrbahn()
s3.zeichne_fahrbahn()
s4.zeichne_fahrbahn()
s5.zeichne_fahrbahn()


# Ampel erstellen (x, y, richtung, zustand, rot, grün)
a1 = Ampel(115, 460, "x", 0, 10, 10) #s1
a2 = Ampel(120, 435, "y", 2, 10, 10) #s4
a3 = Ampel(160, 440, "x", 0, 10, 10) #s1i
a4 = Ampel(140, 480, "y", 2, 10, 10) #s4i
a5 = Ampel(395, 140, "x", 0, 10, 10) #s2
a6 = Ampel(400, 115, "y", 2, 10, 10) #s5
a7 = Ampel(440, 120, "x", 0, 10, 10) #s2i
a8 = Ampel(420, 160, "y", 2, 10, 10) #s5i

s1.fuege_ampel_hinzu(a1)
s1i.fuege_ampel_hinzu(a3)
s4.fuege_ampel_hinzu(a2)
s4i.fuege_ampel_hinzu(a4)
s2.fuege_ampel_hinzu(a5)
s2i.fuege_ampel_hinzu(a7)
s5.fuege_ampel_hinzu(a6)
s5i.fuege_ampel_hinzu(a8)
#s5.fuege_ampel_hinzu(a2)
#s5i.fuege_ampel_hinzu(a4)
s4i.fuege_ampel_hinzu(a8)
s5.fuege_ampel_hinzu(a2)

# Fahrzeuge

for i in range(0,8):
	fuers1 = Fahrzeug(i*60, 465, "x", rd.randint(30,60), 0, rd.randint(30,60), rd.randint(30,60), 30, -30, 1, 10, [rd.randint(100,255),rd.randint(100,255),rd.randint(100,255)],s1)
	fuers1i = Fahrzeug(i*60, 445, "-x", 50, 0, 50, 50, 10, -30, 1, 10, [rd.randint(200,255),rd.randint(200,255),rd.randint(200,255)],s1i)
	fuers2 = Fahrzeug(i*60, 145, "x", 50, 0, 50, 50, 30, -30, 1, 10, [255,255,255],s2)
	fuers2i = Fahrzeug(i*60, 125, "-x", 50, 0, 50, 50, 30, -30, 1, 10, [255,255,255],s2i)
	s1.fuege_fahrzeug_hinzu(fuers1,belegt)
	s1i.fuege_fahrzeug_hinzu(fuers1i,belegt)
	s2.fuege_fahrzeug_hinzu(fuers2,belegt)
	s2i.fuege_fahrzeug_hinzu(fuers2i,belegt)
	
for i in range(0,3):
	fuers5 = Fahrzeug(405, 20*i, "y", 50, 0, 50, 50, 30, -30, 1, 10, [255,255,255],s5)
	fuers4i = Fahrzeug(145, maphoehe*kachelgroesse-(20*i), "-y", 50, 0, 50, 50, 30, -30, 1, 10, [255,255,255],s4i)
	s5.fuege_fahrzeug_hinzu(fuers5,belegt)
	s4i.fuege_fahrzeug_hinzu(fuers4i,belegt)

done = False
while not done:
 
    for event in pygame.event.get():  
        if event.type == pygame.QUIT:
            done = True
 
    # Hintergrundmap
    for row in range(maphoehe):
        for column in range(mapbreite):
			screen.blit(textures[tilemap[row][column]], (column*kachelgroesse,row*kachelgroesse))
        
    # Ampel zeichnen
    a1.phasen(1)
    a2.phasen(1)
    a3.phasen(1)
    a4.phasen(1)
    a5.phasen(1)
    a6.phasen(1)
    a7.phasen(1)
    a8.phasen(1)
    a1.zeichne()
    a2.zeichne()
    a3.zeichne()
    a4.zeichne()
    a5.zeichne()
    a6.zeichne()
    a7.zeichne()
    a8.zeichne()
	
    # Fahrzeuge
    i = 0	
    for fb in fahrbahnliste:
		for fz in fb.fahrzeugliste:
			fz.pruefe_kollision(belegt)
			fz.pruefe_ampel()
			fz.change(fz)
			fz.fahre(fz)
			fz.zeichne() 
			belegt[i] = [fz.x,fz.y]
			i += 1 

    pygame.display.flip()
    
    # Bestimmt die Frameanzahl pro Sekunde
    clock.tick(100)
 
pygame.quit()
